SystemOrganization addCategory: #'Cache-Analysis'!

Object subclass: #AnalysisSetNick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:34'!
browseAllAccessesTo: aVar from: aClass

	SystemNavigation default browseAllAccessesTo: aVar from: aClass! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:43'!
browseAllAccessesToClassVar: aVar from: aClass

	SystemNavigation default browseAllReferencesTo:
		(aClass classPool associationAt: aVar)! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnClassSideIV: ivName inClass: aClass! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:04'!
infoOnClassVariable: cvarName inClass: aClass! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnInstanceSideIV: ivName inClass: aClass! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 13:30'!
manualExample

	AnalysisSetNick new browseAllAccessesToClassVar: #Instances from: MCDefinition.  

	(MCDefinition classPool at: #Instances) class.
	(MCDefinition classPool at: #Instances) size.
	(MCDefinition classPool at: #Instances) anyOne class.! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:44'!
manuallyIDedIWSTpaperSession

	^  { FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session.
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault. }! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:45'!
manuallyIDedIWSTpaperSingletons

	^ {FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session.
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault}! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:42'!
manuallyIDedIWSTpaperVarious

	^ { MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable. }! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:31'!
naiveDetectorCacheIvs

	 ^ {GLMDynamicPresentation->#(#cachedPresentation). PNGReadWriter->#(#cachedDecoderMap). Color->#(#cachedDepth #cachedBitPattern). TextContainer->#(''rectangleCache''). MetacelloCommonMCSpecLoader->#(''disablePackageCache''). FreeTypeFont->#(''widthAndKernedWidthCache'' ''cachedHeight'' ''cachedAscent'' ''cachedDescent''). RBVariableEnvironment->#(''selectorCache''). ColorForm->#(''cachedDepth'' ''cachedColormap''). SystemDictionary->#(''cachedClassNames'' ''cachedNonClassNames''). SpecDebuggerStack->#(#actionsCache). NECSymbols class->#(''cachedSymbols''). EmbeddedFreeTypeFontInstaller->#(#embeddedFileInfoCache). StackLayout->#(''cachedMinExtent'' ''cachedMinExtents''). FreeTypeFontProvider->#(#fileInfoCache). MetacelloCachingGoferResolvedReference->#(''cachedVersion''). RowLayout->#(''cachedMinExtent'' ''cachedMinExtents''). MCHttpRepository->#(#readerCache). HandMorph->#(#cacheCanvas #cachedCanvasHasHoles). MessageBrowser->#(#cachedHierarchy). NewListModel->#(#listItemsCache). GTSpotterContext->#(#cache). RBNamespace->#(''implementorsCache'' ''sendersCache''). ListModel->#(#listItemsCache). RBSentNotImplementedRule->#(#implementorsCache). MetacelloLoaderPolicy->#(''cacheRepository'' ''cacheGofer''). VSCommitBrowser class->#(#commentCache). Termcap->#(''cache''). TableLayout->#(''minExtentCache''). SeamlessFastDNUProxy->#(#cachedClassProxy). PluggableListMorph->#(#hScrollRangeCache). FileDialogWindow->#(#entryCache #entryCacheDirectory). InteractiveResolver->#(''cache''). MailAddressTokenizer->#(#cachedToken). ClassWidget->#(#cachedHierarchy). GoferSynchronize->#(''cacheReferences''). GLMDynamicPresentation2->#(#cachedPresentation). ASTCacheResetTest->#(#cache). MCRepositoryGroup->#(''useCache''). CairoFontMetricsProvider->#(#cache). Gofer->#(''packageCacheRepository'' ''resolvedReferencesCache''). ProgressBarMorph->#(#cachedWidth). MethodFinder->#(#cachedClass #cachedArgNum #cachedSelectorLists). MCCacheRepository->#(#packageCaches #cacheEnabled). RPackageSet class->#(#cacheActive #cachePackages). MetacelloClearStackCacheNotification->#(''cacheNames''). HelpBrowser->#(#helpTopicCache). CharacterSetComplement->#(''byteArrayMapCache''). AlphaImageMorph->#(#cachedForm). CairoFreetypeFontRenderer->#(#cache). MCFileTreeWriter->#(#cachedPackageFileDirectoryEntries). GLMPresentation->#(#cachedDisplayedValue). GTPlayBook class->#(#cacheDirectory). MCFileBasedRepository->#(#cache #cacheFileNames). GLMPane->#(#cachedMatchingPresentations). NewList->#(#listCache #displayListCache #iconCache). CriticBrowser->#(#cache). SingleCodeCriticResultList->#(#cache). AbstractNautilusUI->#(#cachedHierarchy). FreeTypeCacheTest->#(''cache'' ''cache1K'' ''fullCache''). SmalllintManifestChecker->#(''manifestClassCache''). CairoBackendCache->#(''cache''). MCMczReader->#(''infoCache'')}! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:37'!
naiveLRUUsers

	 ^ {BlockClosureTest->#testMemoizedLRUCache . GradientFillStyle class->#initPixelRampCache LRUCacheTests->#newCache . ThemeIcons->#initializeIcons . UITheme->#createArrowImagesCache UITheme->#createBoxImagesCache}
! !

!AnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:39'!
naiveTTLUsers

	 ^ {TTLCacheTests->#newCache}! !

Object subclass: #NaiveCacheDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:36'!
LRUCacheUsers
	"(self new LRUCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ LRUCache allCallsOnIn: SystemNavigation new ! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:38'!
TTLCacheUsers
	"(self new TTLCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ TTLCache allCallsOnIn: SystemNavigation new ! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/26/2015 21:04'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]]! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:13'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]]! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:30'!
cachesInSystem
	"self new cachesInSystem associations printString"
	|classToCacheDict|
	classToCacheDict := Dictionary new.
	ProtoObject allSubclasses do: 
		[ :class | 
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | classToCacheDict at: class put: caches ] ].
	^ classToCacheDict ! !

!NaiveCacheDetector methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:15'!
cachesInSystemIncludingClassVars
	"self new cachesInSystemIncludingClassVars"
	|classToCacheDict|
	classToCacheDict := Dictionary new.
	ProtoObject allSubclasses do: 
		[ :class | 
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | classToCacheDict at: class put: caches ].
			(self cachesForClassInClassVars: class)
				ifNotEmptyDo: [:caches | classToCacheDict at: class put: caches ]. ].
	^ classToCacheDict ! !

Object subclass: #VarEvent
	instanceVariableNames: 'method receiver timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #MsgSendEvent
	instanceVariableNames: 'sender selector args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #ReadEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #WriteEvent
	instanceVariableNames: 'classOfValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

Object subclass: #VarSite
	instanceVariableNames: 'method node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #ReadVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #WriteVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

Object subclass: #VarTrace
	instanceVariableNames: 'classOfVar name proxy testClass initValue timeSortedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassSideIVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #InstSideIVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!
